from algorithms.graph import *


def toposort_stack(g):
    totalorder = []

    def visit(s):
        toexplore = [(s, "visit")]
        s.seen = True
        while len(toexplore) > 0:
            v, todo = toexplore.pop()
            if todo == "visit":
                toexplore.append((v, "done"))
                for w in v.neighbours:
                    if not w.seen:
                        toexplore.append((w, "visit"))
                        w.seen = True
            else:  # todo=="done"
                totalorder.append(v)

    for v in g.vertices:
        v.seen = False
    for v in g.vertices:
        if not v.seen:
            visit(v)
    totalorder.reverse()
    return totalorder


order = toposort_stack(simple_graph_4)
for v in order:
    print(v)
